package com.fr.plugin.decision.request.handler;

import com.finebi.common.api.cell.context.CellCreator;
import com.finebi.common.authority.api.FineAuthorityUtils;
import com.finebi.common.authority.decision.role.FineAuthorityUser;
import com.finebi.common.impl.vo.table.FineBusinessTable;
import com.finebi.common.impl.vo.table.FineExcelBusinessTable;
import com.finebi.direct.common.impl.engine.BurgerTableDataCellImpl;
import com.finebi.burger.api.bean.configuration.table.page.ConfLimitInfo;
import com.finebi.burger.api.bean.configuration.table.page.ConfPageInfo;
import com.finebi.foundation.api.structure.result.BIDetailResult;
import com.fr.json.JSONObject;
import com.fr.web.utils.WebUtils;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.util.ArrayList;
import java.util.List;
import java.util.Optional;

public class CheckSizeHandler extends HWAbstractHandler {
    public static final String PATH="/excelmng/check/size";
    @Override
    protected void deal(HttpServletRequest req, HttpServletResponse res, JSONObject para, JSONObject result) throws Exception {
        JSONObject finalResult = JSONObject.create();

        ArrayList<JSONObject> excelList = new ArrayList<JSONObject>();

        List<FineBusinessTable> allTables = CellCreator.getCellProvider().tableCell().getAllTableWithoutAuth();
        allTables.forEach(fineBusinessTable -> {
            if (fineBusinessTable instanceof FineExcelBusinessTable) {
                try {

                    FineAuthorityUser authorityUser = FineAuthorityUtils.getAuth(req);
                    Optional<BIDetailResult> data = new BurgerTableDataCellImpl().getRealDataWithAuth(fineBusinessTable, new ConfLimitInfo(500000, new ConfPageInfo()), authorityUser);
                    BIDetailResult detailResult = data.get();

                    JSONObject excel = JSONObject.create();
                    excel.put("transferName", fineBusinessTable.getTransferName()).
                            put("rowCount", detailResult.totalRowSize());
                    excelList.add(excel);
                } catch(Exception e){
                    e.printStackTrace();
                }
            }
        });

        WebUtils.printAsJSON(res, finalResult.put("data", excelList));
    }

    @Override
    public String getPath() {
        return PATH;
    }
}
